/*
        Copyright (c) 2004 on behalf of the EU EGEE Project:
        The European Organization for Nuclear Research (CERN),
        Istituto Nazionale di Fisica Nucleare (INFN), Italy
        Datamat Spa, Italy
        Centre National de la Recherche Scientifique (CNRS), France
        CS Systeme d'Information (CSSI), France
        Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
        Universiteit van Amsterdam (UvA), Netherlands
        University of Helsinki (UH.HIP), Finland
        University of Bergen (UiB), Norway
        Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom

        AuthenticationException: an exception related to authentication Cream's fault
	
        Authors: Alvise Dorigo <alvise.dorigo@pd.infn.it>
        Version info: $Id: AuthenticationException.h,v 1.2.4.2 2006/07/25 09:05:39 marzolla Exp $
*/

#ifndef _GLITE_CE_CREAM_CLIENT_API_CREAMEX_AUTHNEX_H_
#define _GLITE_CE_CREAM_CLIENT_API_CREAMEX_AUTHNEX_H_

#include "glite/ce/cream-client-api-c/BaseException.h"

namespace glite {
  namespace ce {
    namespace cream_client_api {
      namespace cream_exceptions {
	
	class AuthenticationException : public BaseException {
	  
	  //	  std::string error_message;
	  
	public:
	  //AuthenticationException(const char* err_info) : error_message(err_info) {}
	  //AuthenticationException(const std::string& err_info) : error_message(err_info) {}
	  AuthenticationException(const std::string& mn,
				  const std::string& ec,
				  const std::string& des,
				  const std::string& fc,
				  const time_t& t) : BaseException(mn, ec, des, fc, t) {}
	  virtual ~AuthenticationException() throw() {}
	  //	  virtual const char* what() const throw() { return error_message.c_str(); }
	};
      }
    }
  }
}

#endif
