#ifndef _GLITE_CE_CREAM_CLIENT_API_SOAPPROXY_COMMAND_H_
#define _GLITE_CE_CREAM_CLIENT_API_SOAPPROXY_COMMAND_H_

#include "glite/ce/cream-client-api-c/cream_client_soapStub.h"
#include <string>
#include <vector>

namespace glite {
  namespace ce {
    namespace cream_client_api {
      namespace soap_proxy {

	class Command {

	  std::string m_name;
	  std::string m_status;
	  std::string m_failureReason;
	  time_t      m_creationTime;
	  time_t      m_startSchedulingTime;
	  time_t      m_startProcessingTime;
	  time_t      m_executionCompletedTime;

	 public:
	  Command(creamtypes__Command*);
	  virtual ~Command() {}
	  std::string getCommandName( void ) const { return m_name; }
	  std::string getStatusName( void ) const { return m_status; }
	  std::string getFailureReason( void ) const { return m_failureReason; }
	  time_t      getCreationTime( void ) const { return m_creationTime; }
	  time_t      getStartSchedulingTime( void ) const { return m_startSchedulingTime; }
	  time_t      getStartProcessingTime( void ) const { return m_startProcessingTime; }
	  time_t      getExecutionCompletedTime( void ) const { return m_executionCompletedTime; }
        };
      }
    }
  }
}
#endif
