/*
        Copyright (c) 2004 on behalf of the EU EGEE Project:
        The European Organization for Nuclear Research (CERN),
        Istituto Nazionale di Fisica Nucleare (INFN), Italy
        Datamat Spa, Italy
        Centre National de la Recherche Scientifique (CNRS), France
        CS Systeme d'Information (CSSI), France
        Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
        Universiteit van Amsterdam (UvA), Netherlands
        University of Helsinki (UH.HIP), Finland
        University of Bergen (UiB), Norway
        Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom

        ExceptionFactory: a class that raises the proper c++ exception when a CREAM fault is received

        Authors: Alvise Dorigo <alvise.dorigo@pd.infn.it>
        Version info: $Id: ExceptionFactory.h,v 1.1.2.7 2006/12/04 08:49:41 marzolla Exp $
*/

#ifndef _GLITE_CE_CREAM_CLIENT_API_SOAPPROXY_EXFACTORY_H_
#define _GLITE_CE_CREAM_CLIENT_API_SOAPPROXY_EXFACTORY_H_

#include "glite/ce/cream-client-api-c/cream_client_soapStub.h"

#include "glite/ce/cream-client-api-c/auth_ex.h"
#include "glite/ce/cream-client-api-c/soap_ex.h"
#include "glite/ce/cream-client-api-c/invalidTimestamp_ex.h"
#include "glite/ce/cream-client-api-c/BaseException.h"
#include "glite/ce/cream-client-api-c/JobUnknownException.h"
#include "glite/ce/cream-client-api-c/InvalidArgumentException.h"
#include "glite/ce/cream-client-api-c/OperationNotSupportedException.h"
#include "glite/ce/cream-client-api-c/NoSuitableResourceException.h"
#include "glite/ce/cream-client-api-c/GridProxyDelegationException.h"
#include "glite/ce/cream-client-api-c/JobStatusInvalidException.h"
#include "glite/ce/cream-client-api-c/GenericException.h"
#include "glite/ce/cream-client-api-c/AuthenticationException.h"
#include "glite/ce/cream-client-api-c/AuthorizationException.h"
#include "glite/ce/cream-client-api-c/DelegationException.h"
#include "glite/ce/cream-client-api-c/InternalException.h"
#include "glite/ce/cream-client-api-c/ConnectionTimeoutException.h"
#include "glite/ce/cream-client-api-c/JobSubmissionDisabledException.h"

#include "boost/thread/recursive_mutex.hpp"

namespace glite {
  namespace ce {
    namespace cream_client_api {
      namespace soap_proxy {
	namespace ExceptionFactory {

   	  /*protected:
	    cefaults__BaseFaultType 			s_BaseFaultTypeObj;
	    _creamfaults__JobUnknownFault 		s_JobUnknownFaultObj;
	    _creamfaults__InvalidArgumentFault 		s_InvalidArgumentFaultObj;
	    _creamfaults__OperationNotSupportedFault 	s_OperationNotSupportedFaultObj;
	    _creamfaults__NoSuitableResourcesFault 	s_NoSuitableResourceFaultObj;
	    _creamfaults__JobSubmissionDisabledFault 	s_JobSubmissionDisabledFaultObj;
	    _creamfaults__GridProxyDelegationFault 	s_GridProxyDelegationFaultObj;
	    _creamfaults__JobStatusInvalidFault 		s_JobStatusInvalidFaultObj;
	    _cefaults__GenericFault 			s_GenericFaultObj;
	    _cefaults__AuthenticationFault 		s_AuthenticationFaultObj;
	    _cefaults__AuthorizationFault 		s_AuthorizationFaultObj;
	    _delegation2__DelegationException 		s_DelegationFault1Obj;
	    //static delegation1__DelegationExceptionType 	s_DelegationFault2Obj;

	  public:

	    //static boost::recursive_mutex m_mutex;
*/
	    void raiseException(struct soap*)
	      throw(glite::ce::cream_client_api::cream_exceptions::BaseException&,
		    glite::ce::cream_client_api::cream_exceptions::JobUnknownException&,
		    glite::ce::cream_client_api::cream_exceptions::InvalidArgumentException&,
		    glite::ce::cream_client_api::cream_exceptions::OperationNotSupportedException&,
		    glite::ce::cream_client_api::cream_exceptions::NoSuitableResourceException&,
		    glite::ce::cream_client_api::cream_exceptions::GridProxyDelegationException&,
		    glite::ce::cream_client_api::cream_exceptions::JobStatusInvalidException&,
		    glite::ce::cream_client_api::cream_exceptions::GenericException&,
		    glite::ce::cream_client_api::cream_exceptions::AuthenticationException&,
		    glite::ce::cream_client_api::cream_exceptions::AuthorizationException&,
		    glite::ce::cream_client_api::cream_exceptions::DelegationException&,
		    glite::ce::cream_client_api::cream_exceptions::InternalException&,
		    glite::ce::cream_client_api::cream_exceptions::JobSubmissionDisabledException&,
		    glite::ce::cream_client_api::cream_exceptions::ConnectionTimeoutException&);
	};
      }
      }
      }
      }
#endif

