/*
        Copyright (c) 2004 on behalf of the EU EGEE Project:
        The European Organization for Nuclear Research (CERN),
        Istituto Nazionale di Fisica Nucleare (INFN), Italy
        Datamat Spa, Italy
        Centre National de la Recherche Scientifique (CNRS), France
        CS Systeme d'Information (CSSI), France
        Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
        Universiteit van Amsterdam (UvA), Netherlands
        University of Helsinki (UH.HIP), Finland
        University of Bergen (UiB), Norway
        Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom

        InternalException: an exception for error other than faults
	
        Authors: Alvise Dorigo <alvise.dorigo@pd.infn.it>
        Version info: $Id: InternalException.h,v 1.1.4.2 2006/07/25 09:05:39 marzolla Exp $
*/

#ifndef _GLITE_CE_CREAM_CLIENT_API_CREAMEX_INTEX_H_
#define _GLITE_CE_CREAM_CLIENT_API_CREAMEX_INTEX_H_

#include<exception>
#include<string>

namespace glite {
  namespace ce {
    namespace cream_client_api {
      namespace cream_exceptions {
	
	class InternalException : public std::exception {
	  
	  std::string m_error_message;
	  
	public:
	  InternalException(const std::string& err_info) 
	    : m_error_message(err_info) {}
	  virtual ~InternalException() throw() {}
	  virtual const char* what() const throw() { 
	    return m_error_message.c_str(); 
	  }
	};
      }
    }
  }
}

#endif
