/*
        Copyright (c) 2004 on behalf of the EU EGEE Project:
        The European Organization for Nuclear Research (CERN),
        Istituto Nazionale di Fisica Nucleare (INFN), Italy
        Datamat Spa, Italy
        Centre National de la Recherche Scientifique (CNRS), France
        CS Systeme d'Information (CSSI), France
        Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
        Universiteit van Amsterdam (UvA), Netherlands
        University of Helsinki (UH.HIP), Finland
        University of Bergen (UiB), Norway
        Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom

        JobStatusInvalidException: an exception for JobStatusInvalid CREAM's fault
	
        Authors: Alvise Dorigo <alvise.dorigo@pd.infn.it>
        Version info: $Id: JobStatusInvalidException.h,v 1.2.4.2 2006/07/25 09:05:39 marzolla Exp $
*/

#ifndef _GLITE_CE_CREAM_CLIENT_API_CREAMEX_JSIEX_H_
#define _GLITE_CE_CREAM_CLIENT_API_CREAMEX_JSIEX_H_

#include "glite/ce/cream-client-api-c/BaseException.h"

namespace glite {
  namespace ce {
    namespace cream_client_api {
      namespace cream_exceptions {
	
	class JobStatusInvalidException : public BaseException {
	  
	public:
	  JobStatusInvalidException(const std::string& mn,
				    const std::string& ec,
				    const std::string& des,
				    const std::string& fc,
				    const time_t& t) : BaseException(mn, ec, des, fc, t) {}

	  virtual ~JobStatusInvalidException() throw() {}
	};
      }
    }
  }
}

#endif
