/*
        Copyright (c) 2004 on behalf of the EU EGEE Project:
        The European Organization for Nuclear Research (CERN),
        Istituto Nazionale di Fisica Nucleare (INFN), Italy
        Datamat Spa, Italy
        Centre National de la Recherche Scientifique (CNRS), France
        CS Systeme d'Information (CSSI), France
        Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
        Universiteit van Amsterdam (UvA), Netherlands
        University of Helsinki (UH.HIP), Finland
        University of Bergen (UiB), Norway
        Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom

        soap_ex: an exception for any kind of communication error and for fault
	raised by the cream service
	
        Authors: Alvise Dorigo <alvise.dorigo@pd.infn.it>
        Version info: $Id: soap_ex.h,v 1.4.4.2 2006/07/25 09:05:40 marzolla Exp $
*/

#ifndef _GLITE_CE_CREAM_CLIENT_API_SOAPPROXY_SOAPEX_H_
#define _GLITE_CE_CREAM_CLIENT_API_SOAPPROXY_SOAPEX_H_

#include<exception>
#include<string>

namespace glite {
  namespace ce {
    namespace cream_client_api {
      namespace soap_proxy {
	
	class soap_ex : public std::exception {
	  
	  std::string m_error_message;
	  
	public:
	  soap_ex(const std::string& err_info) : m_error_message(err_info) {}
	  virtual ~soap_ex() throw() {}
	  virtual const char* what() const throw() { return m_error_message.c_str(); }
	};
      }
    }
  }
}

#endif
